
package misim.plugins;

import java.awt.*;
import java.awt.event.*;
import misim.*;
import misim.util.*;


// an "as is" set of code from russ_s_hensel@yahoo.com



public class SpecialRegister      extends       Plugin
                                  implements    ItemListener, ProcessorListener,
                                                PortListener, ChainedClockListener
{

//; rip of a bread board --


	int     porta,
		trisa,
		portb,
		trisb;

	int     oldporta,
		oldtrisa,
		oldportb,
		oldtrisb;

	ClockListener   nextListener;
	Checkbox        update;
	boolean         atualizar;

        SpecialRegisterDisplay display;


   	public SpecialRegister( Component owner, MachineState machineState,
                  RobustReaderIF reader, String params ) throws MiSimException
  	{
      	    super( owner, machineState, reader, params );
   	}


   	public void init( String params ) throws MiSimException
   	{
   		setLayout(new BorderLayout());
   		setBackground(Color.white);
                setResizable( false );

   		atualizar   = false;

                display     = new SpecialRegisterDisplay();

//   		bread       = new BreadCanvas();
//   		update      = new Checkbox( "Update Scope after each instruction", true );
//   		update.addItemListener(this);
//   		Panel aPanel = new Panel();
//   		aPanel.setLayout( new BorderLayout() );
//   		aPanel.add( update, BorderLayout.CENTER );
//   		add(aPanel,BorderLayout.SOUTH);
//
//   		add(bread,BorderLayout.CENTER);

                setLayout( new BorderLayout() );
   		add( display, BorderLayout.CENTER);

   		oldporta=oldtrisa=oldportb=oldtrisb=5;
   	}

        // =================================

   	public void processorStateChange( int state, String message )
   	{
            System.out.println( "processorStateChange( int state, String message )" );
      	    if( state != Processor.STATE_RUNNING ) updateMonitor();
   	}

        // =================================

   	public void portEvent( int portBits, long clockCount, int portId )
   	{
            System.out.println( "portEvent" + " " + portBits + " " + clockCount + " " + portId );
   	}

        // =================================

   	public int getBitmask( int portId )
   	{
   		return 0;
   	}
        // =================================

   	public void setNext( ClockListener nextListener )
   	{
   	 	 this.nextListener = nextListener;
   	}

        // =================================

   	public ClockListener getNext()
   	{
   		return nextListener;
   	}

        // =================================

   	public void prepare( long clocks )
   	{

   	}

        // =================================

   	public void reset()
   	{
                // update?
   	}

        // =================================
   	public void clockEvent( long clocks )
   	{
              nextListener.clockEvent( clocks );
              //System.out.println( "clockEvent" + " get the registers yourself" );
	      // if(atualizar) updateMonitor();
              updateMonitor();
   	}

        // =================================

   	public void updateMonitor()

   	{
                //String      locSep  = new String( " " );
                long        locClocks;

                int         locWReg;

                display.updateDisplay( this.machineState );


   	}
        // =================================

   	public void showPlugin( boolean visible )
   	{
     		setVisible(visible);
     		if( visible ) {
        		machineState.addClockListener(this);
        		((Processor)machineState).addProcessorListener( this );
         }
                else {
        		machineState.removeClockListener(this);
        		((Processor)machineState).removeProcessorListener( this );
         }

     		updateMonitor();
   	}
        // =================================


   	public int configType()
   	{
      	    return PLUGIN_NONE;
   	}

   	public String getConfig()
   	{
      	    return null;
   	}
        // =================================
   	public String readConfig( String config )
   	{
            //System.out.println( "readConfig( String config )" );
      	    return null;
   	}
        // =================================
   	public String getAbout()
   	{
            System.out.println( "getAbout()" );
            updateMonitor();
      	    //return Txt.get( Txt.PLG_BREAD_ABOUT );

            return "Special Register Display ( version .01 Alpha ) russ_s_hensel@yahoo.com" ;
   	}
        // ===================================
   	public String getHelp()
   	{
      	return null;
   	}

   	public void itemStateChanged( ItemEvent e )
   	{
            System.out.println( "itemStateChanged( ItemEvent e )" );
            if(update.getState())
                    atualizar   = true;
            else
                    atualizar   = false;
   	}

        // =================================

}
